
package org.objectweb.fractal.bf.hdl.reader;
/**
 * An immutable pair of IPs. 
 * The latency attribute defines the latency between the two IPs.
 * @author Valerio Schiavoni <valerio.schiavoni@gmail.com>
 *
 */
public class PairOfIps {
  String fromIp;
  String toIp;
  Integer latency; //the latency between the 2 ip
  
  public PairOfIps(String from, String to, Integer lat) {
    this.fromIp = from;
    this.toIp = to;
    this.latency = lat;
  }
  
  public String toString() {
    return "["+fromIp+","+toIp+","+latency+"]";
  }

  public final String getFrom_ip()
  {
    return fromIp;
  }

  public final String getTo_ip()
  {
    return toIp;
  }

  public final Integer getLatency()
  {
    return latency;
  }

  @Override
  public int hashCode()
  {
    final int prime = 31;
    int result = 1;
    result = prime * result + ((fromIp == null) ? 0 : fromIp.hashCode());
    result = prime * result + ((latency == null) ? 0 : latency.hashCode());
    result = prime * result + ((toIp == null) ? 0 : toIp.hashCode());
    return result;
  }

  @Override
  public boolean equals(Object obj)
  {
    if (this == obj)
      return true;
    if (obj == null)
      return false;
    if (getClass() != obj.getClass())
      return false;
    final PairOfIps other = (PairOfIps) obj;
    if (fromIp == null)
    {
      if (other.fromIp != null)
        return false;
    }
    else if (!fromIp.equals(other.fromIp))
      return false;
    if (latency == null)
    {
      if (other.latency != null)
        return false;
    }
    else if (!latency.equals(other.latency))
      return false;
    if (toIp == null)
    {
      if (other.toIp != null)
        return false;
    }
    else if (!toIp.equals(other.toIp))
      return false;
    return true;
  }
}