
package org.objectweb.fractal.bf.hdl.reader;

import java.util.ArrayList;
import java.util.List;

import org.objectweb.fractal.bf.hdl.graph.Path;


import jdsl.core.util.Converter;
import jdsl.graph.algo.IntegerDijkstraPathfinder;
import jdsl.graph.api.Edge;
import jdsl.graph.api.EdgeIterator;
import jdsl.graph.api.Graph;
import jdsl.graph.api.Vertex;

public class ShortestPathExecutor extends IntegerDijkstraPathfinder
{

  /**
   * @see jdsl.graph.algo.IntegerDijkstraTemplate#weight(jdsl.graph.api.Edge)
   */
  @Override
  protected int weight(Edge edge)
  {
    PairOfIps poi = (PairOfIps) edge.element();

    return poi.latency;
  }
  
  /**
   * Return the shortest path as a list of {@link Edge} objects.
   * @return
   */
  public List<Edge> thePath()
  {

    final ArrayList<Edge> path = new ArrayList<Edge>();
    final EdgeIterator reportPath = reportPath();
   
    Converter.iteratorToList(reportPath, path);
    
    return path;
  }

  /**
   * @param graph
   * @param source
   * @param dest
   * @return
   */
  public Path executeAndReturn(Graph graph, Vertex source, Vertex dest)
  {
    execute(graph,source,dest);
    
    final List<Edge> thePath = thePath();
    
    Path result = new Path(graph, thePath);
    
    return result;
  }
  
  

}
